<?php
// 
// Chapter 12, pg. 321-322
//
require_once "DB.inc";

class Entry {
  public $id;
  public $title;
  public $timestamp;
  private $_body;

  public function __construct($id = false)
  {
    if(!$id) {
      return;
    }
    $dbh = new DB_Mysql_Test;
    $query = "SELECT id, title, timestamp
              FROM entries 
              WHERE id = :1";
    $data = $dbh->prepare($query)->execute($id)->fetch_assoc();
    $this->id = $data['id'];
    $this->title = $data['title'];
    $this->timestamp = $data['timestamp'];
  }

  public function __get($name) {
    if($name == 'body') {
      if($this->id && !$this->_body) {
        $dbh = new DB_Mysql_Test;
        $query = "SELECT body FROM entries WHERE id = :1";
        list($this->_body) = 
          $dbh->prepare($query)->execute($this->id)->fetch_row();
      }
      return $this->_body;
    }
  }

  public function __set($name, $value) 
  {
    if($name == 'body') {
      $this->_body = $value;
    }
  }
}

$entry = new Entry(1);
print_r($entry);
print $entry->body;

/* vim: set ts=2 sts=2 expandtab ai bs=2 : */
?>
