<?php
//
// Chapter 2, pg. 61
//
class Tied {
  private $dbm;
  private $dbmFile;
  function __construct($file = false)
  {
    $this->dbmFile = $file;
    $this->dbm = dba_popen($this->dbmFile, "c", "ndbm");
  }
  function __destruct() 
  {
    dba_close($this->dbm);
  }
  function __get($name)
  {
    $data = dba_fetch($name, $this->dbm);
    if($data) {
      print $data;
      return unserialize($data);
    }
    else {
      print "$name not found\n";
      return false;
    }
  }
  function __set($name, $value)
  {
    dba_replace($name, serialize($value), $this->dbm);
  }
}

$a = new Tied("/tmp/tied.dbm");
if(!$a->counter) {
  // typo: this must be 1
  $a->counter = 1;
}
else {
  $a->counter++;
}
print "This page has been accessed ".$a->counter." times.\n";
?>
