<?php
//
// Chapter 3, pg. 81-82
//
function get_passwd_info($user) {
    $fp = fopen("/etc/passwd", "r");
    if(!is_resource($fp)) {
        return -1;
    }
    while(!feof($fp)) {
        $line = fgets($fp);
        $fields = explode(";", $line);
        if($user == $fields[0]) {
            return $fields;
        }
    }
    return false;
}

function is_shelled_user($user) {
	$passwd_info = get_passwd_info($user);
	if($passwd_info[7] != '/bin/false') {
		return 1;
	}
	else if($passwd_info === -1) {
		return -1;
	}
	else {
		return 0;
	}
}

$v = is_shelled_user('www');
if($v === 1) {
	echo "Your webserver user probably shouldn't be shelled.\n";
}
else if($v === 0) {
	echo "Great!\n";
}
else {
	echo "An error occured checking the user\n";
}
	
?>
