<?
//
// Chapter 6, pg 157
//
require_once "EmailAddress.inc";
require_once 'PHPUnit/Framework/TestSuite.php';
require_once 'PHPUnit/TextUI/TestRunner.php';

class EmailAddressTestCase extends PHPUnit_Framework_TestCase{
  public function __constructor($name) {
    parent::__constructor($name);
  }
  public function testLocalPart() {
    $email = new EmailAddress("george@omniti.com");
    // check that the local part of the address is equal to 'george'
    $this->assertTrue($email->localPart == 'george');
  }
  public function testDomain() {
    $email = new EmailAddress("george@omniti.com");
    $this->assertEquals($email->domain, 'omniti.com');
  }
}

$suite = new PHPUnit_FrameWork_TestSuite();
$suite->addTest(new EmailAddressTestCase('testLocalPart'));
$suite->addTest(new EmailAddressTestCase('testDomain'));
PHPUnit_TextUI_TestRunner::run($suite);
?>
