<?php
//
// Chapter 10, pg 256
//

class Foo {
  public function id() {
    return "I am a Foo";
  }
}

require_once 'Cache/DBM.inc';
$dbm = new Cache_DBM("/data/cachefiles/generic");
if($obj = $dbm->get("foo")) {
  // Cache Hit, $obj is what we were looking for
  print $obj->id();
}
else {
  // Cache Miss, create a new $obj and insert it into the cache
  $obj = new Foo();
  $dbm->put("foo", $obj);
  print $obj->id();
}
// ... use $obj however we want
?>

