<?php
//
// Chapter 10, pg 267-268
//
class Project {
  // attributes of the project
  public $name;
  public $projectid;
  public $short_description;
  public $authors;
  public $long_description;
  public $file_url;

  public function __construct($name=false) {
    if($name) {
      $this->_fetch($name);
    }
  }
  protected function _fetch($name) {
    $dbh = new DB_Mysql_Test;
    $cur = $dbh->prepare("
      SELECT 
        * 
      FROM 
        projects
      WHERE 
        name = :1");
    $cur->execute($name);
    $row = $cur->fetch_assoc();
    if($row) {
      $this->name = $name;
      $this->short_description = $row['short_descrition'];
      $this->author = $row['author'];
      $this->long_description = $row['long_description'];
      $this->file_url = $row['file_url'];
    }
    else {
      throw new Exception;
    }
  }
}

?>
