<?
//
// Chapter 19, pg. 457
//
require_once 'Benchmark/Iterate.php';

class MyBench extends Benchmark_Iterate {
    function run() {
        $arguments     = func_get_args();
        $iterations = array_shift($arguments);
        $function_name = array_shift($arguments);
	$arguments = array_shift($arguments);   
        parent::run($iterations, $function_name, $arguments);
	$oh = new Benchmark_Iterate;
        for ($i = 1; $i <= $iterations; $i++) {
	   $oh->setMarker('start_' . $i); 
	   $oh->setMarker('end_' . $i);
        }
	$oh_result = $oh->get();
	$this->overhead = $oh_result['mean'];
        return(0);
    }
    function get() {
	$result = parent::get();
	$result['mean'] -= $this->overhead;
	$result['overhead'] = $this->overhead;
	return $result;
    }
}
?>
