<?
//
// Chapter 6, pg. 156
//
require_once "EmailAddress.inc";
require_once 'PHPUnit/Framework/TestCase.php';
require_once 'PHPUnit/Framework/TestSuite.php';
require_once 'PHPUnit/TextUI/TestRunner.php';

class EmailAddressTest extends PHPUnit_Framework_TestCase {
  public function __constructor($name) {
    parent::__constructor($name);
  }
  function testLocalPart() {
    $email = new EmailAddress("george@omniti.com");
    // check that the local part of the address is equal to 'george'
    $this->assertTrue($email->localPart == 'george');
  }
}

$suite = new PHPUnit_Framework_TestSuite();
$suite->addTest(new EmailAddressTest('testLocalPart'));



PHPUnit_TextUI_TestRunner::run($suite);
?>

